import threading
import enum

class Waz:
    liczbaPunktow = 0
    pozycjaWezaX = 0
    pozycjaWezaY = 0
    kierunekRuchu = 0
    czyGraDziala = True
    pauza = False
    class Kierunek(enum.Enum):
        polnoc = 0
        wschod = 1
        poludnie = 2
        zachod = 3
    def zmienKierunek(self, kierunek):
        self.kierunekRuchu = kierunek
    def __init__(self, pozycjaWezaX, pozycjaWezaY):
        self.liczbaPunktow = 0
        self.pozycjaWezaX = pozycjaWezaX
        self.pozycjaWezaY = pozycjaWezaY
        self.kierunekRuchu = 0
    def sprawdzWynik(self):
        return self.liczbaPunktow;
    def ustawWynik(self, liczbaPunktowDoUstawienia):
        self.liczbaPunktow = liczbaPunktowDoUstawienia;
    def przesun(self, zamekWeza, zamekGrafiki, plansza):
        import time
        while self.czyGraDziala:
            if self.pauza:
                time.sleep(1)
            else:
                zamekWeza.acquire()
                if self.kierunekRuchu == self.Kierunek.polnoc.value:
                    self.pozycjaWezaY -= 1
                elif self.kierunekRuchu == self.Kierunek.poludnie.value:
                    self.pozycjaWezaY += 1
                elif self.kierunekRuchu == self.Kierunek.zachod.value:
                    self.pozycjaWezaX -= 1
                elif self.kierunekRuchu == self.Kierunek.wschod.value:
                    self.pozycjaWezaX += 1
                if plansza.ileOwocow == 0:
                    waz.czyGraDziala = False
                if self.sprawdzPozycjeY() < 0 or self.sprawdzPozycjeY() >= plansza.rozmiarYPlanszy or self.sprawdzPozycjeX() < 0 or self.sprawdzPozycjeX() >= plansza.rozmiarXPlanszy:
                    zamekGrafiki.release()
                    waz.czyGraDziala = False
                    break
                else:
                    owoc = plansza.pole[self.sprawdzPozycjeY()][self.sprawdzPozycjeX()].owoc
                    if owoc != None:
                        self.zjedzOwoc(plansza.pole[self.sprawdzPozycjeY()][self.sprawdzPozycjeX()])
                    pole = plansza.pole[self.sprawdzPozycjeY()][self.sprawdzPozycjeX()]
                    plansza.zaaktualizujOgonWeza()
                    if pole.wartoscPola > 0:
                        waz.czyGraDziala = False
                    pole.wartoscPola = self.liczbaPunktow + 1
                    time.sleep(1)
                    zamekGrafiki.release()
    def sprawdzPozycjeY(self):
        return self.pozycjaWezaY
    def sprawdzPozycjeX(self):
        return self.pozycjaWezaX
    def ustawPozycje(self, x, y):
        self.pozycjaWezaX = x
        self.pozycjaWezaY = y
    def zjedzOwoc(self, pole):
        self.liczbaPunktow += pole.owoc.sprawdzPunkty()
        plansza.ileOwocow = plansza.ileOwocow - 1
        pole.owoc = None

class Owoc:
    liczbaPunktow = 0
    def __init__(self):
        self.liczbaPunktow = 0
    def sprawdzPunkty(self):
        return self.liczbaPunktow
    def ustawPunkty(self, punkty):
        self.liczbaPunktow = punkty
        return
    
class Plansza:
    rozmiarXPlanszy = 0;
    rozmiarYPlanszy = 0;
    ileOwocow = 0;
    pole = None;
    def __init__(self, rozmiarXPlanszy, rozmiarYPlanszy):
        self.rozmiarXPlanszy = rozmiarXPlanszy
        self.rozmiarYPlanszy = rozmiarYPlanszy
        self.pole = [[Pole() for x in range(rozmiarXPlanszy)] for y in range(rozmiarYPlanszy)]
        self.losujPlansze()
        return
    def losujPlansze(self):
        import random
        for i in range(self.rozmiarYPlanszy):
            for j in range(self.rozmiarXPlanszy):
                if random.randint(1, 100) <= 15:
                    self.pole[i][j].owoc = Owoc()
                    self.pole[i][j].owoc.ustawPunkty(1)
                    self.ileOwocow = self.ileOwocow + 1
        return
    def zresetujPlansze(self):
        return
    def zaaktualizujOgonWeza(self):
        for i in range(self.rozmiarYPlanszy):
            for j in range(self.rozmiarXPlanszy):
                if(self.pole[i][j].wartoscPola > 0):
                    self.pole[i][j].wartoscPola = self.pole[i][j].wartoscPola - 1
        return

class Pole:
    owoc = None
    wartoscPola = 0
    def __init__(self):
        self.owoc = None
        self. wartoscPola = 0
        
class WyswietlanieGrafiki():
    def wyswietlGre(self, plansza, waz, zamekWeza, zamekGrafiki):
        import os
        import time
        while waz.czyGraDziala:
            zamekGrafiki.acquire()
            os.system('CLS')
            print(" ", end='  ');
            for i in range(plansza.rozmiarXPlanszy):
                ramka = i%4
                if ramka == 0 or ramka == 1:
                    print("*", end='  ')
                else:
                    print("-", end='  ')
            print("\n")
            for i in range(plansza.rozmiarYPlanszy):

                ramka = i % 4
                if ramka == 0 or ramka == 1:
                    print("*", end='  ')
                else:
                    print("-", end='  ')

                for j in range(plansza.rozmiarXPlanszy):
                    if waz.pozycjaWezaX == j and waz.pozycjaWezaY == i:
                        print("@", end='  ')
                    elif plansza.pole[i][j].owoc != None:
                        print("$", end='  ')
                    elif plansza.pole[i][j].wartoscPola > 0:
                        print("o", end='  ')
                    else:
                        print(" ", end='  ')
                if ramka == 0 or ramka == 1:
                    print("*", end="  ")
                else:
                    print("-", end="  ")
                print("\n")
            print(" ", end='  ')
            for i in range(plansza.rozmiarXPlanszy):
                ramka = i % 4
                if ramka == 0 or ramka == 1:
                    print("*", end='  ')
                else:
                    print("-", end='  ')
            print("\n")

            zamekWeza.release()
            time.sleep(1)
    
class ObslugaWejscia():
   def zinterpretujWcisnietyPrzycisk(self, waz):
    import msvcrt
    while 1:
        x = msvcrt.getch().decode('ASCII')
        if x == 'a':
            if waz.kierunekRuchu == waz.Kierunek.polnoc.value:
                waz.kierunekRuchu = waz.Kierunek.zachod.value
            elif waz.kierunekRuchu == waz.Kierunek.wschod.value:
            	waz.kierunekRuchu = waz.Kierunek.polnoc.value
            elif waz.kierunekRuchu == waz.Kierunek.poludnie.value:
            	waz.kierunekRuchu = waz.Kierunek.wschod.value
            elif waz.kierunekRuchu == waz.Kierunek.zachod.value:
            	waz.kierunekRuchu = waz.Kierunek.poludnie.value
        elif x == 'd':
            if waz.kierunekRuchu == waz.Kierunek.polnoc.value:
            	waz.kierunekRuchu = waz.Kierunek.wschod.value
            elif waz.kierunekRuchu == waz.Kierunek.wschod.value:
            	waz.kierunekRuchu = waz.Kierunek.poludnie.value
            elif waz.kierunekRuchu == waz.Kierunek.poludnie.value:
            	waz.kierunekRuchu = waz.Kierunek.zachod.value
            elif waz.kierunekRuchu == waz.Kierunek.zachod.value:
            	waz.kierunekRuchu = waz.Kierunek.polnoc.value
        elif x == ' ':
            waz.pauza = not waz.pauza

import configparser
ustawienia = configparser.ConfigParser()
ustawienia.read('plikKonfiguracyjny.ini')
rozmiarX = ustawienia.getint('plansza', 'rozmiarX')
rozmiarY = ustawienia.getint('plansza', 'rozmiarY')
plansza = Plansza(rozmiarX, rozmiarY)
wyswietlanieGrafiki = WyswietlanieGrafiki()
waz = Waz(6, 6)
zamekWeza = threading.Lock()
zamekWyswietlania = threading.Lock()
zamekWeza.acquire()
watekGrafiki = threading.Thread(target=WyswietlanieGrafiki.wyswietlGre, args=(wyswietlanieGrafiki, plansza,waz, zamekWeza, zamekWyswietlania))
obslugaWejscia = ObslugaWejscia()
watekWejscia = threading.Thread(target=ObslugaWejscia.zinterpretujWcisnietyPrzycisk, args=(obslugaWejscia,waz))
watekWeza = threading.Thread(target=Waz.przesun, args=(waz, zamekWeza, zamekWyswietlania, plansza))
watekGrafiki.start()
watekWejscia.start()
watekWeza.start()
watekGrafiki.join()
watekWeza.join()
import os
os.system('CLS')
print("      .")
print("     .|.")
print("     |||")
print("     |||")
print("     |||")
print("     |||")
print("     j_I")
print("    .)_(.")
print("    |===|")
print("    /___\ ")
print("   //___\\ ")
print("  /=======\ ")
print(" / .-\"\"\"-. \ ")
print("|__|     |__|")
print("Twoj wynik punktowy to: " + str(waz.liczbaPunktow))
watekWejscia.join()
